<?php
/**
 * DokuWiki mainscript
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Andreas Gohr <andi@splitbrain.org>
 */

//  xdebug_start_profiling();

if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/');

if (isset($_SERVER['HTTP_X_DOKUWIKI_DO'])){
    $ACT = trim(strtolower($_SERVER['HTTP_X_DOKUWIKI_DO']));
} elseif (!empty($IDX)) {
    $ACT = 'index';
} elseif (isset($_REQUEST['do'])) {
    $ACT = $_REQUEST['do'];
} else {
    $ACT = 'show';
}

require_once '../lib-common.php';
if (!in_array('dokuwiki', $_PLUGINS)) {
    COM_404();
    exit;
}

if ( $ACT == 'admin' ) {
    require_once '../admin/auth.inc.php';
}

require_once(DOKU_INC.'inc/init.php');
require_once(DOKU_INC.'inc/common.php');
require_once(DOKU_INC.'inc/events.php');
require_once(DOKU_INC.'inc/pageutils.php');
require_once(DOKU_INC.'inc/html.php');
require_once(DOKU_INC.'inc/auth.php');
require_once(DOKU_INC.'inc/actions.php');

//login require?
dokuwiki_perm();

//Restric access to group
if ($_DW_CONF['restrict_to_group'] != '' ) {
if (!SEC_inGroup($_DW_CONF['restrict_to_group'])) {
	COM_errorLog("Someone has tried to illegally access the DokuWiki install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
	$display = COM_siteHeader ('menu', $LANG_404[1]);
	$display .= COM_startBlock ($LANG_404[1]);
	if (isset ($_SERVER['SCRIPT_URI'])) {
		$url = strip_tags ($_SERVER['SCRIPT_URI']);
	} else {
		$pos = strpos ($_SERVER['REQUEST_URI'], '?');
		if ($pos === false) {
			$request = $_SERVER['REQUEST_URI'];
		} else {
			$request = substr ($_SERVER['REQUEST_URI'], 0, $pos);
		}
		$url = 'http://' . $_SERVER['HTTP_HOST'] . strip_tags ($request);
	}
	$display .= sprintf ($LANG_404[2], $url);
	$display .= $LANG_404[3];
	$display .= COM_endBlock ();
	$display .= COM_siteFooter ();

	echo $display;
	exit;
}
}

//import variables
$QUERY = trim($_REQUEST['id']);
$ID    = getID();
$NS    = getNS($ID);
$REV   = $_REQUEST['rev'];
$IDX   = $_REQUEST['idx'];
$DATE  = $_REQUEST['date'];
$RANGE = $_REQUEST['lines'];
$HIGH  = $_REQUEST['s'];
if(empty($HIGH)) $HIGH = getGoogleQuery();

$TEXT  = cleanText($_POST['wikitext']);
$PRE   = cleanText($_POST['prefix']);
$SUF   = cleanText($_POST['suffix']);
$SUM   = $_REQUEST['summary'];

//sanitize revision
$REV = preg_replace('/[^0-9]/','',$REV);

//make infos about the selected page available
$INFO = pageinfo();

//export minimal infos to JS, plugins can add more
$JSINFO['id']        = $ID;
$JSINFO['namespace'] = (string) $INFO['namespace'];


// handle debugging
if($conf['allowdebug'] && $ACT == 'debug'){
    html_debug();
    exit;
}

//send 404 for missing pages if configured or ID has special meaning to bots
if(!$INFO['exists'] &&
  ($conf['send404'] || preg_match('/^(robots\.txt|sitemap\.xml(\.gz)?|favicon\.ico|crossdomain\.xml)$/',$ID)) &&
  ($ACT == 'show' || substr($ACT,0,7) == 'export_') ){
    header('HTTP/1.0 404 Not Found');
}

//prepare breadcrumbs (initialize a static var)
if ($conf['breadcrumbs']) breadcrumbs();

// check upstream
checkUpdateMessages();

$tmp = array(); // No event data
trigger_event('DOKUWIKI_STARTED',$tmp);

//close session
session_write_close();

//do the work
act_dispatch($ACT);

$tmp = array(); // No event data
trigger_event('DOKUWIKI_DONE', $tmp);

//  xdebug_dump_function_profile(1);
